]> git.treefish.org Git - backmeupscotty.git/blobdiff - backmeupscotty
formatting; introduced bwlimit
[backmeupscotty.git] / backmeupscotty
index 07a20496a054dc83c54b6351109d837dd6ce4d9d..3a9abb894d91de8b99a81e4af3eeb34e6f63425b 100644 (file)
@@ -5,54 +5,93 @@ REMOTE_DIR=/tmp/backmeupscotty/test
 ARCHIVE_KEEPNBACKUPS=30
 ARCHIVE_KEEPNDAYS=30
 BACKUP_RUNEVERYNTHDAY=1
 ARCHIVE_KEEPNBACKUPS=30
 ARCHIVE_KEEPNDAYS=30
 BACKUP_RUNEVERYNTHDAY=1
+BWLIMIT=500KiB
 
 
-function upperme {
-    echo $(basename $0) | tr '[:lower:]' '[:upper:]'
+_ERROR_ENCOUNTERED=0
+
+function timestamp {
+    date +'[%y-%m-%d|%H:%M:%S]'
+}
+
+function scottyline {
+    echo $(timestamp) $@
 }
 
 function scottyinfo {
 }
 
 function scottyinfo {
-    echo $(upperme): $@ 
+    if [ $_ERROR_ENCOUNTERED -eq 0 ]; then
+        scottyline $@
+    else
+           scottyline $@ >&2
+    fi
 }
 
 function scottyerror {
 }
 
 function scottyerror {
-    echo $(upperme): $@ >&2 
+    scottyline $@ >&2
+    if [ $_ERROR_ENCOUNTERED -eq 0 ]; then
+           _ERROR_ENCOUNTERED=1
+           scottyline "Going into verbose mode after error encounter." >&2
+    fi
+}
+
+function ssh255 {
+    ssh $@
+    sshret=$?
+
+    if [ $sshret -eq 255 ]; then
+           scottyerror "SSH connection failed!"
+           exit 1
+    else
+           return $sshret
+    fi
 }
 
 function grepbackups {
 }
 
 function grepbackups {
-    ssh $REMOTE_HOST "ls $REMOTE_DIR" | grep -E '[0-9]+-[0-9]+'
+    ssh255 $REMOTE_HOST "ls $REMOTE_DIR" | grep -E '[0-9]+-[0-9]+'
 }
 
 function isIncomplete {
 }
 
 function isIncomplete {
-    if ( ssh $REMOTE_HOST '[ -d '$REMOTE_DIR/incomplete' ]' ); then
-       return 0
+    if ( ssh255 $REMOTE_HOST '[ -d '$REMOTE_DIR/incomplete' ]' ); then
+           return 0
     else
     else
-       return 1
+           return 1
     fi
 }
 
     fi
 }
 
-function isIncompleteOrNthDay {
-    if isIncomplete || \
-       [ $(( ( $(date +%s) / (60*60*24) ) % $BACKUP_RUNEVERYNTHDAY )) -eq 0 ]; 
+function isNthDay {
+    if [ $(( ( $(date +%s) / (60*60*24) ) % $BACKUP_RUNEVERYNTHDAY )) -eq 0 ];
     then
     then
-       return 0
+           return 0
     else
     else
-       return 1
-    fi 
+           return 1
+    fi
+}
+
+function latestTooOld {
+    for oldbackup in $(grepbackups); do
+           tstamp=$(echo $oldbackup | cut -d'-' -f1)
+
+           if [ $(( $(date +%s) - $tstamp )) -lt $(( ($BACKUP_RUNEVERYNTHDAY*24+12)*60*60 )) ]
+           then
+               return 1
+           fi
+    done
+
+    return 0
 }
 
 function scottysync {
     timestamp=$(date +%s)
 
 }
 
 function scottysync {
     timestamp=$(date +%s)
 
-    scottyinfo Syncing $SYNC_SRC to $REMOTE_HOST:$REMOTE_DIR @$timestamp
+    scottyinfo "Syncing $SYNC_SRC to $REMOTE_HOST:$REMOTE_DIR @$timestamp."
 
     if [ ! -d "$SYNC_SRC" ]; then
 
     if [ ! -d "$SYNC_SRC" ]; then
-       scottyerror Source dir $SYNC_SRC does not exist. Not syncing!
-       return 1
+           scottyerror "Source dir $SYNC_SRC does not exist. Not syncing!"
+           return 1
     fi
 
     if [ $(ls -A "$SYNC_SRC" | wc -l) -eq 0 ]; then
     fi
 
     if [ $(ls -A "$SYNC_SRC" | wc -l) -eq 0 ]; then
-       scottyerror Source dir $SYNC_SRC is empty. Not syncing!
-       return 1
+           scottyerror "Source dir $SYNC_SRC is empty. Not syncing!"
+           return 1
     fi
 
     dir_current=$REMOTE_DIR/current
     fi
 
     dir_current=$REMOTE_DIR/current
@@ -60,116 +99,134 @@ function scottysync {
     dir_timestamped=$REMOTE_DIR/$timestamp-$(date -d @$timestamp +%Y%m%d%H%M%S)
 
     if [ -z $SYNC_EXC ]; then
     dir_timestamped=$REMOTE_DIR/$timestamp-$(date -d @$timestamp +%Y%m%d%H%M%S)
 
     if [ -z $SYNC_EXC ]; then
-       rsync_exclude=""
+           rsync_exclude=""
     else
     else
-       rsync_exclude=$(eval echo --exclude={$SYNC_EXC} | tr -d {})
+           rsync_exclude=$(eval echo --exclude={$SYNC_EXC} | tr -d {})
     fi
 
     fi
 
-    if (ssh $REMOTE_HOST '[ ! -d '$REMOTE_DIR' ]'); then
-       scottyinfo Creating destination directory $REMOTE_HOST:$REMOTE_DIR
-       ssh $REMOTE_HOST "mkdir $REMOTE_DIR"
+    if (ssh255 $REMOTE_HOST '[ ! -d '$REMOTE_DIR' ]'); then
+           scottyinfo "Creating destination directory $REMOTE_HOST:$REMOTE_DIR."
+           ssh255 $REMOTE_HOST "mkdir $REMOTE_DIR"
     fi
 
     if isIncomplete; then
     fi
 
     if isIncomplete; then
-       scottyerror Continuing old incomplete backup
+           scottyerror "Continuing old incomplete backup."
     fi
 
     fi
 
-    scottyinfo Starting rsync
-    rsync -e ssh \
-       -v -aHAX --numeric-ids --delete --delete-excluded \
-       --link-dest=$dir_current \
-       $rsync_exclude \
-       $SYNC_SRC/ $REMOTE_HOST:$dir_incomplete/
-    
+    scottyinfo "Starting rsync."
+    rsync -e ssh --bwlimit=$BWLIMIT \
+          -v -aHAX --numeric-ids --delete --delete-excluded \
+          --link-dest=$dir_current \
+          $rsync_exclude \
+          $SYNC_SRC/ $REMOTE_HOST:$dir_incomplete/
+
     if [ $? -eq 0 ]; then
     if [ $? -eq 0 ]; then
-       scottyinfo Timestamping completed backup and linking to current backup
-       ssh $REMOTE_HOST \
-           "mv $dir_incomplete $dir_timestamped && rm -f $dir_current && ln -s $(basename $dir_timestamped) $dir_current"
+           scottyinfo "Timestamping completed backup and linking to current backup."
+           ssh255 $REMOTE_HOST \
+                  "mv $dir_incomplete $dir_timestamped && rm -f $dir_current && \
+               ln -s $(basename $dir_timestamped) $dir_current"
+    else
+           scottyerror "Rsync failed."
     fi
 
     while [ $(grepbackups | wc -l) -gt $ARCHIVE_KEEPNBACKUPS ]; do
     fi
 
     while [ $(grepbackups | wc -l) -gt $ARCHIVE_KEEPNBACKUPS ]; do
-       oldestbackup=$(grepbackups | head -1)
-       oldestbackuptstamp=$(echo $oldestbackup | cut -d'-' -f1)
-
-       if [ $oldestbackuptstamp -lt $(( $(date +%s) - $ARCHIVE_KEEPNDAYS*60*60*24 )) ]; then
-           scottyinfo Removing old backup $oldestbackup
-           ssh $REMOTE_HOST rm -r "$REMOTE_DIR/$oldestbackup"
-       else
-           break
-       fi
+           oldestbackup=$(grepbackups | head -1)
+           oldestbackuptstamp=$(echo $oldestbackup | cut -d'-' -f1)
+
+           if [ $oldestbackuptstamp -lt $(( $(date +%s) - $ARCHIVE_KEEPNDAYS*60*60*24 )) ]; then
+               scottyinfo "Removing old backup $oldestbackup."
+               ssh255 $REMOTE_HOST rm -r "$REMOTE_DIR/$oldestbackup"
+           else
+               break
+           fi
     done
 }
 
 function deleteLock {
     done
 }
 
 function deleteLock {
-    if ! rmdir /tmp/$(basename $0).lock; then
-       scottyerror "Could not delete lockfile /tmp/$(basename $0).lock!"
+    if ! rmdir /var/lock/$(basename $0); then
+           scottyerror "Could not delete lockfile /tmp/$(basename $0).lock!"
     fi
 }
 
     fi
 }
 
-function prepare {
-    scottyinfo "Preparing for sync"
-}
-
 function cleanup_abort {
 function cleanup_abort {
-    scottyinfo "No cleanup_abort function was defined."
-}
+    scottyerror "Caught exit signal! Cleaning up."
 
 
-function _cleanup_abort {
-    scottyerror "Caught exit signal! Cleaning up..."
-
-    cleanup_abort
+    cleanup ABORT
 
     if [ $(jobs -p) ]; then
 
     if [ $(jobs -p) ]; then
-       scottyerror TERMinating remaining child processes...
-       kill $(jobs -p)
+           scottyerror "TERMinating remaining child processes."
+           kill $(jobs -p)
     fi
     fi
+
     deleteLock
     deleteLock
+
     exit
 }
 
     exit
 }
 
-function prepare {
-    scottyinfo "No prepare function was defined."
+function cleanup {
+    scottyinfo "No cleanup function was defined."
 }
 
 }
 
-function _prepare {
-    prepare
+function prepare {
+    scottyinfo "No prepare function was defined."
 }
 
 function cleanup_normal {
 }
 
 function cleanup_normal {
-    scottyinfo "No cleanup_normal function was defined."
+    cleanup
+    deleteLock
 }
 
 }
 
-function _cleanup_normal {
-    cleanup_normal
+function printhelp {
+    cat <<EOF
+Usage: $(basename $0) [OPTION]...
+
+Recognized options:
+  -q   Only output errors
+  -n   Run only on nth day
+  -h   Print out this help
+EOF
 }
 
 function backmeupscotty {
 }
 
 function backmeupscotty {
-    while getopts "qn:" opt; do
-       case $opt in
-           q)
-               exec > /dev/null
-               ;;
-           n)
-               BACKUP_RUNEVERYNTHDAY=$OPTARG
-               ;;
-       esac
+    while getopts "qn:h" opt; do
+           case $opt in
+               q)
+                       exec > /dev/null
+                       ;;
+               n)
+                       BACKUP_RUNEVERYNTHDAY=$OPTARG
+                       ;;
+               h)
+                       printhelp
+                exit 0
+                ;;
+           esac
     done
 
     done
 
-    if ! isIncompleteOrNthDay; then
-       scottyinfo "This is not the nth day and no incomplete backup exists."
-       exit 0
+    ssh255 $REMOTE_HOST exit
+
+    if latestTooOld; then
+           scottyerror "The latest backup is too old."
+    elif isNthDay; then
+           scottyinfo "This is the nth day."
+    else
+           scottyinfo "No backup has to be done. Exiting."
+           exit 0
     fi
 
     fi
 
-    trap _cleanup_abort EXIT
+    scottyinfo "Performing backup."
 
 
-    _prepare
+    trap cleanup_abort EXIT
+
+    prepare
     scottysync
     scottysync
-    _cleanup_normal
 
 
-    trap deleteLock EXIT
+    trap cleanup_normal EXIT
+
+    exit 0
 }
 
 }
 
-if ! mkdir /tmp/$(basename $0).lock; then
+if ! mkdir /var/lock/$(basename $0); then
     scottyerror "Another instance of $(basename $0) is still running!"
     exit 1
 else
     scottyerror "Another instance of $(basename $0) is still running!"
     exit 1
 else